#include once "SimpleGadget.bas"
#include once "StringGadget.bas"
#include once "ScrollBar.bas"
#include once "ListBox.bas"
#include once "Label.bas"
#include once "MessageBox.bas"

namespace sGUI

'InitGFX m u s s aufgerufen worden sein
declare function FileRequester overload (posx as integer,posy as integer,BtnText as string,Path as string, File as string="",Filter as string="*",FExistMode as integer=0) as string
declare function FileRequester (posx as integer,posy as integer,BtnText as string,Path as string, File as string="",FExistMode as integer=0) as string

declare sub FindContent(gad as Gadget ptr,t as string, filter as string )
/'
function FileRequester(posx as integer,posy as integer,BtnText as string,Path as string, File as string="",FExistMode as integer=0) as string
  function=""

  'Sichern des vom Requester bedeckten Hintergrundes
  dim as FB.Image ptr gfxbackup
  gfxbackup=imagecreate(400,300)
  get (posx,posy)-(posx+399,posy+299),gfxbackup
  
  FillA(posx,posy,400,300,GadgetColor,0)
  FrameB(posx+2,posy+21,396,277,1)
  ClearBox(posx+3,posy+22,394,275)
  'draw string (posx+5, posy+3),BtnText & "...",TextColor
  drawstring (0,posx+5, posy+3,BtnText & "...",TextColor)
  dim as string sep,drive,originpath=curdir
  'Windows Variante
  #ifdef __fb_win32__
    sep="\"
  #endif
  'Tux Variante
  #ifdef __FB_LINUX__
    sep="/"
  #endif

  dim as integer rows
  if fontheight=8  then rows=22
  if fontheight=14 then rows=12
  if fontheight=16 then rows=11

  dim as string entry,GoToFolder,full
  GoToFolder=""
  entry=""
  chdir Path
  Path=curdir
  drive=left(Path,1)


  dim as EventHandle ptr event=new EventHandle

  dim as Gadget ptr labelp,labelf,doit,cancel,strpath,strfile,contlist,cdparent

  labelp  =AddLabel(event,posx+5, posy+28,phrase_path & ":",TextColor)
  strpath =AddStringGadget(event,posx+52,posy+25,38,Path,,,1)
  contlist=AddListBox(event,posx+5,posy+54,46,rows)
  labelf  =AddLabel(event,posx+5, posy+245,phrase_file & ":",TextColor)
  strfile =AddStringGadget(event,posx+62,posy+242,29,File,,,1)
  doit    =AddSimpleGadget(event,posx+309,posy+242,85,23,BtnText)
  cancel  =AddSimpleGadget(event,posx+309,posy+271,85,23,phrase_cancel)
  cdparent=AddSimpleGadget(event,posx+370,posy+25,24,23,"..")

  TO_ClearText(contlist)
  FindContent(contlist,"D")
  FindContent(contlist,"F")
  UpdateGadget(contlist)

  GadgetOn(labelp,cdparent)
  do
    event->xSleep(1,0)
    if event->GADGETMESSAGE then
      select case event->GADGETMESSAGE

        'Pfadeingabe
        case strpath
          chdir GetString(strpath)           'Wechsel ins Directory
          Path=curdir                        'Setze aktuellen Pfad
          
          TO_ClearText(contlist)
          FindContent(contlist,"D")
          FindContent(contlist,"F")
          UpdateGadget(contlist)

          SetString(strpath,Path)                     'Aktualisiere die Pfadanzeige

        case contlist
          entry=TO_GetLineContent(contlist,GetListBoxVal(contlist))

          if entry<>"" then
            if left(entry,6)="<DIR> " then                'wenn entry ein Directory
              GoToFolder=right(entry,len(entry)-6)
              chdir GoToFolder                   'Wechsel ins Directory
              Path=curdir                        'Setze aktuellen Pfad

              TO_ClearText(contlist)
              FindContent(contlist,"D")
              FindContent(contlist,"F")
              UpdateGadget(contlist)

              SetString(strpath,Path)                     'Aktualisiere die Pfadanzeige
            else                                          'ansonsten ist entry ein Dateiname
              File=entry
              SetString(strfile,File)
            end if
          end if

        case cdparent
          chdir ".."                                  'Wechsel ins bergeordnete Directory
          Path=curdir                        'Setze aktuellen Pfad
          
          TO_ClearText(contlist)
          FindContent(contlist,"D")
          FindContent(contlist,"F")
          UpdateGadget(contlist)

          SetString(strpath,Path)                     'Aktualisiere die Pfadanzeige        

				'Beenden und Rckabe eines Strings
        case strfile,doit
          File=GetString(strfile)
          if File<>"" then
            if right(Path,1)<> sep then
              full=Path & sep & File
            else
              full=Path & File
            end if
            if FExistMode then
              if fileexists(full) then
                function=full
                event->EXITEVENT=1
              else
                GadgetSleep(labelp,cdparent)
                MessageBox(posx+20,posy+100,phrase_fileaccessdenied,phrase_error,MBType_OK)
                RestoreActivation(labelp,cdparent)
              end if
            else
              function=full
              event->EXITEVENT=1
            end if
          end if

        'Abbruch des FileRequesters
        case cancel
          event->EXITEVENT=1
          function=""

      end select
    end if
  loop until event->EXITEVENT
  delete event
  chdir originpath
  put (posx,posy),gfxbackup,pset
  imagedestroy gfxbackup
end function
'/

function FileRequester(posx as integer,posy as integer,BtnText as string,Path as string, File as string="",Filter as string="*",FExistMode as integer=0) as string
  function=""
  
  'alle Gren abhngig von den verwendeten Fonts berechnen
  dim as integer heightrun
  dim as integer str_chars,str_width,str_posx
  dim as integer lbx_rows,lbx_chars,lbx_width,lbx_height
  dim as integer btn_width,btn_posx
  dim as integer rowsize,l_offsety,s_offsetx,s_offsety
  dim as integer win_width,win_height,spacer,gui_posx,gui_posy,cont_width,cont_height
  
  'Listbox
  lbx_chars=int(8/GetFixedWidth * 46)'je kleiner der Font, desto mehr Zeilen fr die ListBox im Directory Mode
  lbx_rows=int(16/GetFontHeight(1) * 11)'same ;) als Referenz gilt der 16x8 Standard FB Font, ListBox ist dort 11x46  
  'so berechnet die Listbox selbst seine Breite/Hhe:
  'gad->gadw=NumChars*GetFixedWidth + 2*sGUIMainGap + sGUIMainSize
  'gad->gadh=NumRows*GetFontHeight(1) + 2*sGUIMainGap
  lbx_width=lbx_chars*GetFixedWidth + 2*sGUIMainGap + sGUIMainSize
  lbx_height=lbx_rows*GetFontHeight(1) + 2*sGUIMainGap  
  
  'gemeinsame Zeilenhhe(aber auch als Breitenma genutzt) fr Label,Buttons und StringGadget
  'ist "normalerweise" so hoch wie das StringGadget.
  'falls der Proportionalfont jedoch hher sein sollte, dann diese Hhe als Berechnungsgrundlage nehmen  
  rowsize=iif( GetFontHeight > (GetFontHeight(1) + 2*sGUIMainGap), GetFontHeight , (GetFontHeight(1) + 2*sGUIMainGap) )
  'daraus ergeben sich dann offsets fr kleinere Gadgets
  l_offsety=(rowsize - GetFontHeight)/2
  s_offsety=(rowsize - (GetFontHeight(1) + 2*sGUIMainGap) )/2   
  
  'Gesamthhe Fenster
  spacer=sGUIMainGap 
  'Fensterrahmen mit einbeziehen!
  'Fensterinhalt Breite/Hhe
  cont_width=lbx_width + 2*spacer
  cont_height=lbx_height + 4*rowsize + 6*spacer'ListBox + 4xGadgetZeilen + 6xSpacer
  'Fenster Gesamt- Breite/Hhe
  win_width=cont_width + 2*spacer
  win_height=cont_height + spacer + GetFontHeight + 2*sGUIMainGap'+ unterer Rand und Fake-Kopfzeile
  'Lage Inhalt bzw der GUI
  gui_posx=posx + sGUIMainGap
  gui_posy=posy + GetFontHeight + 2*sGUIMainGap
  
  'Sichern des vom Requester bedeckten Hintergrundes
  dim as FB.Image ptr gfxbackup
  gfxbackup=imagecreate(win_width,win_height)
  get (posx,posy)-(posx+win_width-1 , posy+win_height-1),gfxbackup  
  
  FillA(posx,posy,win_width,win_height,GadgetColor,0)
  ClearBox(gui_posx,gui_posy,cont_width,cont_height)
  FrameB(gui_posx,gui_posy,cont_width,cont_height,1)
  
  'draw string (posx+5, posy+3),BtnText & "...",TextColor
  drawstring (0,posx+sGUIMainGap,posy+sGUIMainGap,BtnText & "...",TextColor)  
  
  dim as string sep,drive,originpath=curdir
  'Windows Variante
  #ifdef __fb_win32__
    sep="\"
  #endif
  'Tux Variante
  #ifdef __FB_LINUX__
    sep="/"
  #endif 
  dim as string entry,GoToFolder,full
  GoToFolder=""
  entry=""
  chdir Path
  Path=curdir
  drive=left(Path,1)

  dim as EventHandle ptr event=new EventHandle
  dim as Gadget ptr cdparent,strpath
  dim as Gadget ptr contlist
  dim as Gadget ptr strfilter
  dim as Gadget ptr labelf,strfile
  dim as Gadget ptr doit,cancel
  
  '***Parent Button
  heightrun=gui_posy + spacer 
  cdparent=AddSimpleGadget(event,gui_posx+spacer,heightrun,rowsize,rowsize,"..") 
  
  '***Path StringGadget
  'StrinGadget Breite und x-Position
  str_width=cont_width - rowsize - 3*spacer'vorhandener Platz frs StringGadget  
  'so berechnet das StringGadget selbst seine Breite:
  'gad->gadw=NumChars * GetFixedWidth + 2*sGUIMainGap
  str_chars=(str_width-2*sGUIMainGap)/GetFixedWidth'Anzahl Zeichen brauchen wir spter als Parameter
  str_width=str_chars * GetFixedWidth + 2*sGUIMainGap'reale Breite des StringGadget
  str_posx=gui_posx + cont_width - str_width - spacer
  strpath =AddStringGadget(event,str_posx,heightrun+s_offsety,str_chars,Path,,,1)
  
  '***Directory ListBox
  heightrun+=rowsize + spacer
  contlist=AddListBox(event,gui_posx+spacer,heightrun,lbx_chars,lbx_rows)
  
  '***Filter StringGadget
  heightrun+=lbx_height + spacer  
  'StringGadget Breite und x-Position
  'Breite Label: labelf->gadw  
  str_width=(cont_width - 2*spacer)/3'vorhandener Platz frs StringGadget  
  str_chars=(str_width-2*sGUIMainGap)/GetFixedWidth'Anzahl Zeichen brauchen wir spter als Parameter
  str_width=str_chars * GetFixedWidth + 2*sGUIMainGap'reale Breite des StringGadget
  str_posx=gui_posx + cont_width - str_width - spacer  
  strfilter =AddStringGadget(event,str_posx,heightrun+s_offsety,str_chars,File,,,1)
  SetString(strfilter, Filter) 
  
  '***File Label
  heightrun+=rowsize + spacer  
  labelf  =AddLabel(event,gui_posx+spacer,heightrun,phrase_file & ":",TextColor)  
  
  '***Filter StringGadget
  'StringGadget Breite und x-Position
  'Breite Label: labelf->gadw  
  str_width=cont_width - labelf->gadw - 3*spacer'vorhandener Platz frs StringGadget  
  str_chars=(str_width-2*sGUIMainGap)/GetFixedWidth'Anzahl Zeichen brauchen wir spter als Parameter
  str_width=str_chars * GetFixedWidth + 2*sGUIMainGap'reale Breite des StringGadget
  str_posx=gui_posx + cont_width - str_width - spacer  
  strfile =AddStringGadget(event,str_posx,heightrun+s_offsety,str_chars,File,,,1)

  '***DoIt Button
  heightrun+=rowsize + spacer
  btn_width=(cont_width-3*spacer)/2
  doit    =AddSimpleGadget(event,gui_posx+spacer,heightrun,btn_width,rowsize,BtnText)
  
  '***Cancel Button
  btn_posx=gui_posx+btn_width+2*spacer
  cancel  =AddSimpleGadget(event,btn_posx,heightrun,btn_width,rowsize,phrase_cancel)


  TO_ClearText(contlist)
  FindContent(contlist,"D",GetString(strfilter))
  FindContent(contlist,"F",GetString(strfilter))
  UpdateGadget(contlist)

  GadgetOn(cdparent,cancel)
  do
    event->xSleep(1,0)
    if event->GADGETMESSAGE then
      select case event->GADGETMESSAGE

        'Pfadeingabe
        case strpath
          chdir GetString(strpath)           'Wechsel ins Directory
          Path=curdir                        'Setze aktuellen Pfad
          
          TO_ClearText(contlist)
          FindContent(contlist,"D",GetString(strfilter))
          FindContent(contlist,"F",GetString(strfilter))
          UpdateGadget(contlist)

          SetString(strpath,Path)                     'Aktualisiere die Pfadanzeige
      
        case strfilter
          chdir GetString(strpath)           'Wechsel ins Directory
          Path=curdir                        'Setze aktuellen Pfad
          if GetString(strfilter)="" then SetString(strfilter, "*")          
          TO_ClearText(contlist)
          FindContent(contlist,"D",GetString(strfilter))
          FindContent(contlist,"F",GetString(strfilter))
          UpdateGadget(contlist)

          SetString(strpath,Path)                     'Aktualisiere die Pfadanzeige        
        case contlist
          entry=TO_GetLineContent(contlist,GetListBoxVal(contlist))

          if entry<>"" then
            if left(entry,6)="<DIR> " then                'wenn entry ein Directory
              GoToFolder=right(entry,len(entry)-6)
              chdir GoToFolder                   'Wechsel ins Directory
              Path=curdir                        'Setze aktuellen Pfad

              TO_ClearText(contlist)
              FindContent(contlist,"D",GetString(strfilter))
              FindContent(contlist,"F",GetString(strfilter))
              UpdateGadget(contlist)

              SetString(strpath,Path)                     'Aktualisiere die Pfadanzeige
            else                                          'ansonsten ist entry ein Dateiname
              File=entry
              SetString(strfile,File)
            end if
          end if

        case cdparent
          chdir ".."                                  'Wechsel ins bergeordnete Directory
          Path=curdir                        'Setze aktuellen Pfad
          
          TO_ClearText(contlist)
          FindContent(contlist,"D",GetString(strfilter))
          FindContent(contlist,"F",GetString(strfilter))
          UpdateGadget(contlist)

          SetString(strpath,Path)                     'Aktualisiere die Pfadanzeige        

				'Beenden und Rckabe eines Strings
        case strfile,doit
          File=GetString(strfile)
          if File<>"" then
            if right(Path,1)<> sep then
              full=Path & sep & File
            else
              full=Path & File
            end if
            if FExistMode then
              if fileexists(full) then
                function=full
                event->EXITEVENT=1
              else
                GadgetSleep(cdparent,cancel)
                MessageBox(posx+20,posy+100,phrase_fileaccessdenied,phrase_error,MBType_OK)
                RestoreActivation(cdparent,cancel)
              end if
            else
              function=full
              event->EXITEVENT=1
            end if
          end if

        'Abbruch des FileRequesters
        case cancel
          event->EXITEVENT=1
          function=""

      end select
    end if
  loop until event->EXITEVENT
  delete event
  chdir originpath
  put (posx,posy),gfxbackup,pset
  imagedestroy gfxbackup
end function

'alte Syntax, aber neuer Requester
function FileRequester (posx as integer,posy as integer,BtnText as string,Path as string, File as string="",FExistMode as integer=0) as string
  function=FileRequester (posx,posy,BtnText,Path, File,"*",FExistMode)
end function


sub FindContent(gad as Gadget ptr,t as string, filter as string )
  dim as integer attr
  dim as string entryname,pre
  if ucase(t)="D" then 'bei "D" suche nach Verzeichnissen
    attr=&H10 + &H01
    pre="<DIR> "       '"Vorsilbe" um Verzeichnisse von Dateien unterscheiden zu knnen
  end if
  if ucase(t)="F" then  'bei "F" suche nach Dateien
    attr=&H00
    pre=""
  end if

  entryname=dir(filter ,attr)
  do
    if (len(entryname)>0) and (entryname<>".") and (entryname<>"..") then TO_AppendLine(gad,pre & entryname)
    entryname=dir
  loop while len(entryname)
end sub

end namespace
